/*
 objet grid
 Contient routes les positions utiles des objets dans la page
 reçoit les infos et calcule les positions des frames, la position du texte
 
 est ensuite appelé par
 grid.displayframe(1,image, texte) pour afficher de l'image 1
 grid.displayfooter(texte) pour les infos du footer
 */

class gridsubs {

  int nbw=2;
  int nby=2;
  int[] margin= {100, 100, 100, 100}; // marges dans le sens horlogique, début en top
  int gutter=10; // espace entre deux images (vertical et horizontal)
  int subTextHeight=20; // taille du texte
  int subLead=22; // interlignage
  int subTopMargin= 10; // décalage vertical des sous-titres: négatif= à l'intérieur de l'image
  int subBoxHeight= 70; // hauteur de la boite de texte +- hauteur du lead X3

  float subPosx=0;
  float subPosy=0;
  float subWidth=0;
  float subHeight=0;

  //int subPadding=10; // retrait latéral des sous-titres
  color subTextColor=color(0); // couleur du texte
  color subBgColor=color(255); // couleur du texte


  // calculé
  float imWidth=10.0;
  float imHeight=10.0;
  float frameBoxWidth=10.0;
  float frameBoxHeight=10.0;


  // constructeur
  gridsubs(
    int nbw, int nby,
    int[] margin, int gutterx, int guttery,
    int subTopMargin, int subBoxHeight, int subPadding,

    int subTextHeight, int subLead,
    color subTextColor, color subBgColor,
    int imw, int imh
    ) {
    this.nbw=nbw;
    this.nby=nby;
    this.margin=margin;
    this.gutter=gutter;

    this.subTopMargin=subTopMargin;
    this.subBoxHeight=subBoxHeight;

    this.subTextHeight=subTextHeight;
    this.subLead=subLead;

    this.subTextColor=subTextColor;
    this.subBgColor=subBgColor;

    imWidth=(width-(margin[1]+margin[3])-(gutterx*(nbw-1)))/nbw;
    float ratio= (imh*1.0) / (imw*1.0);
    imHeight=imWidth * ratio;

    println("Taille des images : "+imWidth + " / " + imHeight+" , ratio "+ratio);

    // taille de la boite
    frameBoxWidth=imWidth;
    if (subTopMargin < 0) {
      frameBoxHeight=imHeight;
    } else {
      frameBoxHeight=imHeight + subTopMargin + subBoxHeight;
    }

    // position et taille des sous-titres
    subPosx=subPadding;
    subPosy=imHeight + subTopMargin;
    subWidth=imWidth-(subPadding*2);
    subHeight=subBoxHeight;

    println("box str : "+subPosx+" - "+subPosy + " - "+subWidth+" - "+subHeight);
  }

  // afficher
  void displayStill(int num, PImage im, String text) {

    // identifier le numéro dans la grille
    int posx = num % nbw;
    int posy = int(num / nbw);
    //println("pour num "+num+", posx est "+posx+" et posy "+posy);

    float px=margin[3]+((frameBoxWidth+gutterx)*posx);
    float py=margin[0]+((frameBoxHeight+guttery)*posy);
    image(im, px, py, imWidth, imHeight);

    textFont(subtitleFont, subTextHeight);
    textLeading(subLead);

    if (subTopMargin < 0) {
      fill(subBgColor);
      text(text, px+subPosx+2, py + subPosy+2, subWidth, subHeight);
    }

    fill(subTextColor);
    text(text, px+subPosx, py + subPosy, subWidth, subHeight);
  }
}
