import processing.video.*;
import processing.pdf.*;
PGraphicsPDF pdf;
PFont coverTitleFont, coverTextFont, subtitleFont;
Movie mov;

/*
MOVIEPRINT
 PDF from movie with srt
 Stéphane Noël - 2013/2014/2024
 
 Aller dans l'onglet "Configuration" pour paramétrer le livre à produire
 Régler la taille du pdf en sortie dans la ligne 29 de ce fichier
 
 */




gridsubs mygrid;
int compteur=0;
int page=1;

String sub_text="";
int adjuster;
float prev_pointmedian=0;
float prev_end=27;

void setup() {
  size(1191, 1684); // 1191 x 1684 est un format DIN recommandé
  textAlign(CENTER, CENTER);

  // récupération des sous-titres
  subtitleVector = new ArrayList();
  creervecteur();
  // recuperer le passage du dernier sous-titre
  SubtitleUnit SU=(SubtitleUnit) subtitleVector.get(subtitleVector.size()-1);
  length_srt=SU.endTime+5000;
  // démarrage du film et taille de l'image
  mov = new Movie(this, srtvideoname);
  mov.play();
  delay(500);
  while (mov.available() == false) {
    delay(10);
  }
  mov.read();
  println("taille de la vidéo : "+mov.width+"/"+mov.height);

  mygrid = new gridsubs(
    nbw, nbh,
    margin,
    gutterx, guttery,
    subTopMargin, subBoxHeight, subPadding,
    subTextHeight, subLead,
    subTextColor, subBgColor,
    mov.width, mov.height
    );

  pdf = (PGraphicsPDF)beginRecord(PDF, srtFileoutput);
  beginRecord(pdf);
  coverTextFont=createFont(textfont, 32);
  coverTitleFont=createFont(titlefont, 32);
  subtitleFont=createFont(subfont, 32);
  textAlign(CENTER);
  commencelivre();
  mov.jump(0); // remettre à 0 le film
}

void draw() {

  background(255);
  int gridpos=0;
  while (compteur < subtitleVector.size()) {
    get_subtitle(compteur);
    float pointmedian=(sub_start + ((sub_end - sub_start)/2))/1000;
    float lengthbetween=(sub_start-prev_end)/1000;
    if(lengthbetween > intervalle){
      int nb_images=int(lengthbetween/intervalle);
      float s=lengthbetween/nb_images;
      for (float ix=prev_end+s; ix<pointmedian; ix+=s) {
        getImage(ix);
        mygrid.displayStill(gridpos, mov, "");
        gridpos=getNewGridPos(gridpos);
        println("intervalle : "+ix);
      }
    }
    
   
    jumpmovto(pointmedian);
    mygrid.displayStill(gridpos, getImage(pointmedian), sub_text);
    prev_pointmedian=pointmedian;
    prev_end=sub_end;
    gridpos=getNewGridPos(gridpos);
    compteur++;


    if (keyPressed == true) {
      println("cut!");
      break;
    }
  }
  
  finitlivre();
  println("Livre terminé");
  exit();
}

int getNewGridPos(int tp) {
  tp++;
  if (tp == (nbw * nbh)) {
    bas_de_page(page);
    println("saut de page : "+compteur+"/"+subtitleVector.size());
    tp=0;
    page++;
    pdf.nextPage();
  }
  return tp ;
}

void jumpmovto(float t) {
  mov.play();
  mov.jump(t);
  mov.read();
  while (mov.time()>=t) {
    mov.read();
    delay(10);
  }
  mov.read();
  mov.pause();
}

PImage getImage(float t) {
  mov.play();
  mov.jump(t);
  mov.read();
  while (!mov.available()) {
    mov.read();
    delay(10);
  }
  mov.read();
  mov.pause();


  PImage r= mov;
  return r;
}

void keyPressed() {
  if (key=='x') {
    finitlivre();
  }
}
